function [P,lookup] = AnnotateGraph(A,Coords,bitmap)

disp('Extracting graph parameters....');

NEdges= sum(sum(A,2))/2;

lookup = zeros(size(A));

P = zeros(NEdges,2);

newP = 1;

for i =1:size(A,1)
    
    for j =1:size(A,2)
        
        if A(i,j) > 0 % edge?
            if lookup(j,i)== 0 % new edge?
                P(newP,1) = hypot(Coords(i,2)/10-Coords(j,2)/10,Coords(i,1)/10-Coords(j,1)/10);  % this is TMin
                [x,y] = bresenham(Coords(i,2),Coords(i,1),Coords(j,2),Coords(j,1));
                n = numel(x);
                P(newP,2) = 2 * P(newP,1);
                for k = 1:n
                    if bitmap(y(k),x(k)) < 10
                        P(newP,2) = 10 * P(newP,1);
                        break
                    end
                end
                lookup(i,j) = newP;
                newP = newP + 1;
            else
                lookup(i,j) = lookup(j,i); 
            end
        end    
    end
    
end

display('done')