function H = ComputeHittingTimes(P)

% compute hitting times H(i,j) for the Markov Chain given the transition
% probability matrix P
% This can surely be written 1000 times better...

H = zeros(size(P));
n = size(P,1);
N = n * (n-1);

% must setup n^2-n linear equations

% create aliases
AH = zeros(size(P));
Lin = zeros(N,2);

K = 1;

for i = 1:n
    for j = 1:n
        if i ~= j
            AH(i,j) = K;
            Lin(K,1) = i;
            Lin(K,2) = j;
            K = K+1;
        end
    end
end

b = ones(N,1);
A = zeros(N,N);

for eq = 1:N
   
    i = Lin(eq,1);
    v = Lin(eq,2);
    
    % Setting up equation for H(i,v)
    
    A(eq,eq) = 1-P(i,i);
    for j = 1:n
        if ( j ~= i ) && (j ~= v)
            row = AH(j,v);
            A(eq,row) = -P(i,j);
        end
    end
    
    
end

Hsol = linsolve(A,b);

for eq = 1:N
    i = Lin(eq,1);
    j = Lin(eq,2);
    H(i,j) = Hsol(eq);
end

% Tested; seems to work