function p = OccupancyProbability(k,n,j)

global BigInstance;
global LowerUpperApproximation;

% computes the probability that by throwing k balls into n bins there are
% j empty cells

% see http://probabilityandstats.wordpress.com/2010/03/27/the-occupancy-problem/
% and http://probabilityandstats.wordpress.com/2010/04/04/a-formula-for-the-occupancy-problem/

p = 0;

if j == 0
    for i =0:n
        if BigInstance == 0
            p = p + (-1)^i*nchoosek(n,i)*((1-i/n)^k);
        else
            if LowerUpperApproximation == 1
                p = p + ((-1)^i)*((n/i)^i)*((1-i/n)^k);
            else
                p = p + ((-1)^i)*(n^i/factorial(i))*((1-i/n)^k);
            end
        end
    end
else
    for i = 0:n-j
        p = p + (-1)^i*nchoosek(n-j,i)*((1-(j+1)/n)^k);
    end
    p = p*nchoosek(n,j);
end