function d = PickRandomDestination(s,GoalDestinations)

% picks a random destination for a robot making sure it does not pick the
% deployment vertex

global SAMPLING_STRATEGY;
global distance

% s: deployment (source) vertex
% vector of goal destinations

if SAMPLING_STRATEGY==1 % Uniform Sampling
    
    N = numel(GoalDestinations);
    
    d = s;
    while d==s
        d = GoalDestinations(ceil(N*rand(1)));
    end
    
elseif SAMPLING_STRATEGY==2 % weighted
    
    dist =  sqrt((distance(GoalDestinations)));
   % dist = ones(size(distance(GoalDestinations)));
    
    den = sum(dist);
    roulette = cumsum(dist/den);
    
    pos = rand(1);
    d = 1;
    while roulette(d) < pos
        d = d+1;
    end
    
    
    d = GoalDestinations(d);
    
end