function p = ProbabilityNotBiGivenADifferentS(i,distances,Params,Lookup)

global N; % number of vertices in the graph
global K; % number of robots in the team
global T;
global SFunctionHandle;



p = 0;

h = 2*distances(i);

% first find worst Sfunction
NEdges = size(Params,1);
TMinw = Params(1,1);
TMaxw = Params(1,2);
worst = SFunctionHandle(T/h,TMinw,TMaxw);

for i = 2:NEdges
    tmp = SFunctionHandle(T/h,Params(i,1),Params(i,2));
    if tmp < worst
        worst = tmp;
        TMinw = Params(i,1);
        TMaxw = Params(i,2);
    end
end


for k=1:K-(N-1)
   
    f1 = (1-SFunctionHandle(T/h,TMinw,TMaxw)^h)^k;
    f2 = BoundedBinomial(k);
    p = p+f1*f2;
end

end

function p = BoundedBinomial(k)

global K;
global N;
global BigInstance;
global LowerUpperApproximation;
global DebugInfo;

if BigInstance==0
    p = nchoosek(K,k)*(1/N)^k*(1-1/N)^(K-k);
else
    if LowerUpperApproximation == 1
        p = ((K/k)^k)*(1/N)^k*(1-1/N)^(K-k);
    else
        fact = (K^k/factorial(k));
        if isnan(fact) || isinf(fact)
            if DebugInfo == 1
                fprintf('BoundedBinomial: Overflow detected for K=%d and k=%d. Correcting.\n',K,k);
            end
            l = k*log(K) - (k*log(k)-k);
            fact = exp(l);
        end
        p = fact*(1/N)^k*(1-1/N)^(K-k);
    end
end

% normalizer so that probabilities add to 1
eta = 0;

for k=1:K-(N-1)
    if BigInstance == 0
        eta = eta + nchoosek(K,k)*(1/N)^k*(1-1/N)^(K-k);
    else
        if LowerUpperApproximation == 1
            eta = eta + ((K/k)^k)*(1/N)^k*(1-1/N)^(K-k);
        else
            fact = (K^k/factorial(k));
            if isnan(fact) || isinf(fact)
                if DebugInfo == 1
                    fprintf('BoundedBinomial: Overflow detected for K=%d and k=%d. Correcting.\n',K,k);
                end
                l = k*log(K) - (k*log(k)-k);
                fact = exp(l);
            end
            eta = eta +  fact*(1/N)^k*(1-1/N)^(K-k);
        end
    end
end

p = p/eta;

end
