function f = SolvePointToPoint(s,d,A,Params,lookup)

global T % global temporal deadline
global DeltaT % discretization step
global SFunctionHandle

% solves the point-to-point problem from (s)ource to (d)estination with a
% given (A)diacency matrix

paths = irreducible_paths(A,s,d,50);
npaths = size(paths,1);

bestvalue = 0;


% for every irreducible path
for i = 1:npaths
    % build instance of the optimization problem
    vertices = paths(i,:);
    vertices = vertices(vertices>0);
    nedges = numel(vertices)-1; % number of edges in the current path.
    % nedges is also the number of classes in the multiclass problem
    edges = cell(1,nedges);
    for j = 1:nedges
        source = vertices(j);
        destination = vertices(j+1); % consider edge u,v
        position = lookup(source,destination);
        start = ceil(Params(position,1)/DeltaT)*DeltaT;
        howmany = ceil((T-start)/DeltaT);
        w = zeros(1,howmany);
        v = zeros(1,howmany);
        w(1) = start;
        v(1) = SFunctionHandle(w(1),Params(position,1),Params(position,2));
        for k = 2:howmany
            w(k) = w(k-1) + DeltaT;
            v(k) = SFunctionHandle(w(k),Params(position,1),Params(position,2));
        end
        edge = struct('w', w, 'v', v,'source',source,'destination',destination);
        edges{j} = edge;
    end
    instance = struct('T', T,'edges',{edges}); 
    % this needs to be fixed!!
    [sol val] = solveMultiClassKnapsack(instance);

    val = -1*val;
    
    if val > bestvalue
        bestvalue = val;
        bestsolution = sol;
        bestedges = edges;
    end
end

f = cell(1,numel(bestedges));

for i = 1:numel(bestedges)
    edge = bestedges{i};
    tmp = struct('source',edge.source,'destination',edge.destination,'t',0);
%     if numel(edge.v) > numel( sol)
%         disp('Ci siamo')
%     end
    slice = bestsolution(1:numel(edge.v));
    tmp.t = edge.w(find(slice>0));
    f{i} = tmp;
    bestsolution(1:numel(edge.v)) = [];
end

