% first build figures for bound comparisons
% 
  clear all
  close all
  
%%

% this is Figure 1 in the paper

figure

N = 10;
p = numel(10:50);
i= 1;
XMIN = 10;
XMAX = 50;
for K = XMIN:XMAX
    p(i) = OccupancyProbability(K,N,0);
    i = i+1;
end

plot(10:50,1-p,'LineWidth',3);
 axis([XMIN XMAX 0 1.1])
xlabel('K','FontSize',30);
ylabel('Error lower bound','FontSize',30);
title('N=10','FontSize',30);
set(gca,'FontSize',30);
grid on
print(gcf,'-depsc2','prXgreater0.eps')

%%


TMin = 10;
TMax = 40;

y =zeros(numel(0:TMax+20),1);
i = 1;
for t = 0:TMax+20
    y(i) = SigmoidTransitionProbability(t,TMin,TMax);
    i = i+1;
end
t = 0:TMax+20;
figure
plot(t,y,'LineWidth',3);
axis([0 TMax+20 0 1.1])

xlabel('t','FontSize',30);
ylabel('Probability of Success','FontSize',30);
title('S function','FontSize',30);
set(gca,'FontSize',30);
grid on
text(8, 0.07, 'T_1', 'Color', 'k','FontSize',30);
text(40, 0.88, 'T_2', 'Color', 'k','FontSize',30);
print(gcf,'-depsc2','sfunction.eps')


%% 
figure 
hold on
grid on
% 
simplemap_deployment=load('PaperData/simplemap_deployment_equalS.mat');
plot(simplemap_deployment.LowerBoundK:simplemap_deployment.step:simplemap_deployment.UpperBoundK,simplemap_deployment.successProbabilityDeployment,'r','LineWidth',2);

simplemapBound_lower = load('PaperData/simplemap_bound_equalS_lower.mat');
plot(simplemapBound_lower.LowerBoundK:simplemapBound_lower.step:simplemapBound_lower.UpperBoundK,simplemapBound_lower.successProbability,'--','LineWidth',2);


simplemapBound_upper = load('PaperData/simplemap_bound_equalS_upper.mat');
plot(simplemapBound_upper.LowerBoundK:simplemapBound_upper.step:simplemapBound_upper.UpperBoundK,simplemapBound_upper.successProbability,'-.','LineWidth',2);

axis([simplemapBound_lower.LowerBoundK simplemapBound_lower.UpperBoundK 0 1.05])
ylabel('Success Probability','FontSize',20)
xlabel('K','FontSize',20)
title('Simple map','FontSize',20)
legend('Experimental Probability','Bound  from below','Bound  from above','Location','Best')
h = gca;
set(h,'FontSize',20);
set(gca,'FontSize',20);

print(gcf,'-depsc2','simplemap_equals.eps')

%%
figure
hold on
grid on

sdr40_deployment = load('PaperData/sdr40_deployment_equalS.mat');
plot(sdr40_deployment.LowerBoundK:sdr40_deployment.step:sdr40_deployment.UpperBoundK,sdr40_deployment.successProbabilityDeployment,'r','LineWidth',2);

sdr40Bound_lower = load('PaperData/sdr40_bound_equalS_lower.mat');
plot(sdr40Bound_lower.LowerBoundK:sdr40Bound_lower.step:sdr40Bound_lower.UpperBoundK,sdr40Bound_lower.successProbability,'--','LineWidth',2);


sdr40Bound_upper = load('PaperData/sdr40_bound_equalS_upper.mat');
plot(sdr40Bound_upper.LowerBoundK:sdr40Bound_upper.step:sdr40Bound_upper.UpperBoundK,sdr40Bound_upper.successProbability,'-.','LineWidth',2);

axis([sdr40Bound_lower.LowerBoundK sdr40Bound_lower.UpperBoundK 0 1.05])
ylabel('Success Probability','FontSize',20)
xlabel('K','FontSize',20)
title('SDR 40','FontSize',20)
legend('Experimental Probability','Bound  from below','Bound  from above','Location','Best')
h = gca;
set(h,'FontSize',14);
set(gca,'FontSize',20);

print(gcf,'-depsc2','sdr40_equals.eps')


%% 
figure 
hold on
grid on

simplemapBound_lower = load('PaperData/simplemap_bound_differentS_lower.mat');
plot(simplemapBound_lower.LowerBoundK:simplemapBound_lower.step:simplemapBound_lower.UpperBoundK,simplemapBound_lower.successProbability,'--','LineWidth',2);


simplemapBound_upper = load('PaperData/simplemap_bound_differentS_upper.mat');
plot(simplemapBound_upper.LowerBoundK:simplemapBound_upper.step:simplemapBound_upper.UpperBoundK,simplemapBound_upper.successProbability,'-.','LineWidth',2);

s1 = load('PaperData/simplemap_deployment_differentS_1.mat');
s2 = load('PaperData/simplemap_deployment_differentS_2.mat');
s3 = load('PaperData/simplemap_deployment_differentS_3.mat');
s4 = load('PaperData/simplemap_deployment_differentS_4.mat');

steps= [s1.LowerBoundK:s1.step:s1.UpperBoundK s2.LowerBoundK:s2.step:s2.UpperBoundK s3.LowerBoundK:s3.step:s3.UpperBoundK s4.LowerBoundK:s4.step:s4.UpperBoundK]; 
successProbabilityDeployment = [s1.successProbabilityDeployment s2.successProbabilityDeployment s3.successProbabilityDeployment s4.successProbabilityDeployment];

plot(steps,successProbabilityDeployment,'r','LineWidth',2)




axis([simplemapBound_lower.LowerBoundK simplemapBound_lower.UpperBoundK 0 1.05])
ylabel('Success Probability','FontSize',20)
xlabel('K','FontSize',20)
title('Simple map','FontSize',20)
legend('Bound  from below','Bound  from above','Experimental Probability','Location','Best')
h = gca;
set(h,'FontSize',14);
set(gca,'FontSize',20);
print(gcf,'-depsc2','simplemap_differents.eps')




%%
figure
hold on
grid on


sdr40Bound_lower = load('PaperData/sdr40_bound_differentS_lower.mat');
plot(sdr40Bound_lower.LowerBoundK:sdr40Bound_lower.step:sdr40Bound_lower.UpperBoundK,sdr40Bound_lower.successProbability,'--','LineWidth',2);


sdr40Bound_upper = load('PaperData/sdr40_bound_differentS_upper.mat');
plot(sdr40Bound_upper.LowerBoundK:sdr40Bound_upper.step:sdr40Bound_upper.UpperBoundK,sdr40Bound_upper.successProbability,'-.','LineWidth',2);

sdr40_s1 = load('PaperData/sdr40_deployment_differentS_1.mat');
sdr40_s2 = load('PaperData/sdr40_deployment_differentS_2.mat');
sdr40_s3 = load('PaperData/sdr40_deployment_differentS_3.mat');
sdr40_s4 = load('PaperData/sdr40_deployment_differentS_4.mat');

steps= [sdr40_s1.LowerBoundK:sdr40_s1.step:sdr40_s1.UpperBoundK sdr40_s2.LowerBoundK:sdr40_s2.step:sdr40_s2.UpperBoundK sdr40_s3.LowerBoundK:sdr40_s3.step:sdr40_s3.UpperBoundK sdr40_s4.LowerBoundK:sdr40_s4.step:sdr40_s4.UpperBoundK]; 
successProbabilityDeployment = [sdr40_s1.successProbabilityDeployment sdr40_s2.successProbabilityDeployment sdr40_s3.successProbabilityDeployment sdr40_s4.successProbabilityDeployment];

plot(steps,successProbabilityDeployment,'r','LineWidth',2)

axis([sdr40Bound_lower.LowerBoundK sdr40Bound_lower.UpperBoundK 0 1.05])
ylabel('Success Probability','FontSize',20)
xlabel('K','FontSize',20)
title('SDR 40','FontSize',20)
legend('Bound  from below','Bound  from above','Experimental Probability','Location','Best')
h = gca;
set(h,'FontSize',14);
set(gca,'FontSize',20);
print(gcf,'-depsc2','sdr40_differents.eps')
