clc
close all
clear all

% global parameters
T = 10; % temporal deadline
K = 4; % number of robots exploring the environment
S = 1; % deployment vertex



%adjacency matrix of the graph to be explored; MUST be symmetric
A = [ 0 1 1 0 ;
      1 0 0 1 ; 
      1 0 0 1 ;
      0 1 1 0 ];
  
if A ~= A'
    error('Adjacency matrix must be symmetric');
end

N = size(A,1); % number of vertices in the graph



if K < N
    error('Number of robots must be greater or equal than the number of nodes');
end


global distances;
global parent;
[distances,parent] = Dijkstra(A,S);

target = zeros(K,1);

for i = 1:K % now plan for each robot
   
    t = S;
    while t == S
        t = ceil(rand(1)*N); % pick a random vertex
    end
    target(i) = t;
    
    PointToPoint(S,t,T);
    
end