clear all
close all
clc

% let A be the adjacency matrix. A must be symmetric
A = [ 0 1 1 0 ;
      1 0 0 1 ; 
      1 0 0 1 ;
      0 1 1 0 ];
    
if A ~= A'
    error('Adjacency matrix must be symmetric');
end

% let Tmax be my target time
Tmax = 5;

% let C be the confidence level
C = 0.95;

v = Dijkstra(A,1);
n = max(v); % max number of hops
t = Tmax/n; % time spent on every edge towards fastest target

p = ComputeProbabilityFromTime(t);

success = p^n; % success probability of a single robot along the critical path;

k = ceil(log(1-C)/log(1-success))